package com.hamish.payumoney;

import android.app.Activity;
import android.content.Intent;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;
import java.util.Map;

import io.flutter.app.FlutterActivity;
import io.flutter.app.FlutterApplication;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.common.PluginRegistry.ActivityResultListener;

import com.payumoney.core.PayUmoneyConfig;
import com.payumoney.core.PayUmoneyConstants;
import com.payumoney.core.PayUmoneySdkInitializer;
import com.payumoney.sdkui.ui.utils.PayUmoneyFlowManager;
import com.payumoney.core.entity.TransactionResponse;
import com.payumoney.sdkui.ui.utils.ResultModel;
import com.payumoney.core.PayUmoneyConstants;

import static android.app.Activity.RESULT_OK;
import static android.content.ContentValues.TAG;

/** PayumoneyPlugin */
public class PayumoneyPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware, ActivityResultListener{

  private MethodChannel channel;
  private ActivityPluginBinding pluginBinding;
    private static PayumoneyPlugin instance;
  private Result pendingResult;
  private PayUmoneySdkInitializer.PaymentParam mPaymentParams;

  private String paymentId = "Payment Failed";
  private Activity activity;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
      channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "payumoney");
    channel.setMethodCallHandler(this);

  }

    public static void registerWith(Registrar registrar) {

    if(instance==null)
    {
      final MethodChannel channel = new MethodChannel(registrar.messenger(), "payumoney");
      instance=new PayumoneyPlugin();
      channel.setMethodCallHandler(instance);
    }


  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (pendingResult != null) {
        pendingResult=null;
      //result.error("ALREADY_ACTIVE", "Payment in progress", null);
      //return;
    }
    pendingResult=result;

    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    }
    else if (call.method.equals("getPayu")) {
      HashMap<String,String> hashMap=call.arguments();
     launchPayUMoneyFlow(hashMap);

    }else {
      result.notImplemented();
    }
  }


  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    onDetachedFromActivity();
  }

  @Override
  public void onAttachedToActivity(ActivityPluginBinding activityPluginBinding) {
    pluginBinding=activityPluginBinding;
    activity=activityPluginBinding.getActivity();
    activityPluginBinding.addActivityResultListener(this);

  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
      onDetachedFromActivity();
  }

  @Override
  public void onReattachedToActivityForConfigChanges(ActivityPluginBinding activityPluginBinding) {
    onAttachedToActivity(activityPluginBinding);

  }

  @Override
  public void onDetachedFromActivity() {
    pluginBinding.removeActivityResultListener(this);
    activity=null;
    this.pluginBinding=null;
  }

  @Override
  public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
    if (requestCode == PayUmoneyFlowManager.REQUEST_CODE_PAYMENT && resultCode == RESULT_OK && data !=
            null) {
      TransactionResponse transactionResponse = data.getParcelableExtra(PayUmoneyFlowManager
              .INTENT_EXTRA_TRANSACTION_RESPONSE);
      ResultModel resultModel = data.getParcelableExtra(PayUmoneyFlowManager.ARG_RESULT);
      if (transactionResponse != null && transactionResponse.getPayuResponse() != null) {
        if (transactionResponse.getTransactionStatus().equals(TransactionResponse.TransactionStatus.SUCCESSFUL)) {
          //Success Transaction
          String merchantResponse = transactionResponse.getTransactionDetails();

          paymentId = "Payment Successful Ref id: " + merchantResponse;
          Toast.makeText(activity.getBaseContext(), "Successful Ref id: " + merchantResponse, Toast.LENGTH_SHORT).show();
         pendingResult.success(paymentId);
          return true;
        } else {
          //Failure Transaction
          Toast.makeText(activity.getBaseContext(), "Failed", Toast.LENGTH_SHORT).show();
          pendingResult.success(null);
          return false;
        }

      } else {
        Log.d(TAG, "Both objects are null!");
        return false;

      }
    }
    return false;
  }

  public void launchPayUMoneyFlow(HashMap<String,String> list){
    PayUmoneyConfig payUmoneyConfig = PayUmoneyConfig.getInstance();

    //Use this to set your custom text on result screen button
    payUmoneyConfig.setDoneButtonText("Payment Success");

    //Use this to set your custom title for the activity
    payUmoneyConfig.setPayUmoneyActivityTitle("Payment Process");

    payUmoneyConfig.disableExitConfirmation(false);

    PayUmoneySdkInitializer.PaymentParam.Builder builder = new PayUmoneySdkInitializer.PaymentParam.Builder();

    //double amount = 0;
    boolean isDebug= (list.get("devmode").equals("false")?false:true);

    String udf1 = "";
    String udf2 = "";
    String udf3 = "";
    String udf4 = "";
    String udf5 = "";
    String udf6 = "";
    String udf7 = "";
    String udf8 = "";
    String udf9 = "";
    String udf10 = "";

    String hash = list.get("hash");
   // builder.setAmount(String.valueOf(amount))
    builder.setAmount(list.get("amount"))
            .setTxnId(list.get("txnId"))
            .setPhone(list.get("phone"))
            .setProductName(list.get("product"))
            .setFirstName(list.get("firstname"))
            .setEmail(list.get("email"))
            .setsUrl("https://www.payumoney.com/mobileapp/payumoney/success.php")
            .setfUrl("https://www.payumoney.com/mobileapp/payumoney/failure.php")
            .setUdf1(udf1)
            .setUdf2(udf2)
            .setUdf3(udf3)
            .setUdf4(udf4)
            .setUdf5(udf5)
            .setUdf6(udf6)
            .setUdf7(udf7)
            .setUdf8(udf8)
            .setUdf9(udf9)
            .setUdf10(udf10)
            .setIsDebug(isDebug)
            .setKey(list.get("mkey"))
            .setMerchantId(list.get("mid"));


    try {
      mPaymentParams = builder.build();
      mPaymentParams.setMerchantHash(hash);
      //mPaymentParams = calculateServerSideHashAndInitiatePayment1(mPaymentParams);
      PayUmoneyFlowManager.startPayUMoneyFlow(mPaymentParams, activity, AppPreference.selectedTheme, true);

      // payuResponse

    } catch (Exception e) {
      Log.println(Log.ERROR, "Error", e.getMessage());
      // some exception occurred
      Toast.makeText(activity, e.getMessage(), Toast.LENGTH_LONG).show();
      //payNowButton.setEnabled(true);

    }
  }

  }
